EAPI EAPI_WEAK const Efl_Event_Description _EFL_TEXT_INTERACTIVE_EVENT_PREEDIT_CHANGED =
   EFL_EVENT_DESCRIPTION("preedit,changed");
EAPI EAPI_WEAK const Efl_Event_Description _EFL_TEXT_INTERACTIVE_EVENT_HAVE_SELECTION_CHANGED =
   EFL_EVENT_DESCRIPTION("have_selection,changed");
EAPI EAPI_WEAK const Efl_Event_Description _EFL_TEXT_INTERACTIVE_EVENT_SELECTION_CHANGED =
   EFL_EVENT_DESCRIPTION("selection,changed");
EAPI EAPI_WEAK const Efl_Event_Description _EFL_TEXT_INTERACTIVE_EVENT_REDO_REQUEST =
   EFL_EVENT_DESCRIPTION("redo,request");
EAPI EAPI_WEAK const Efl_Event_Description _EFL_TEXT_INTERACTIVE_EVENT_UNDO_REQUEST =
   EFL_EVENT_DESCRIPTION("undo,request");
EAPI EAPI_WEAK const Efl_Event_Description _EFL_TEXT_INTERACTIVE_EVENT_CHANGED_USER =
   EFL_EVENT_DESCRIPTION("changed,user");
EAPI EAPI_WEAK EFL_FUNC_BODY_CONST(efl_text_interactive_main_cursor_get, Efl_Text_Cursor_Object *, NULL);

static Eina_Error
__eolian_efl_text_interactive_selection_allowed_set_reflect(Eo *obj, Eina_Value val)
{
   Eina_Error r = 0;   Eina_Bool cval;
   if (!eina_value_bool_convert(&val, &cval))
      {
         r = EINA_ERROR_VALUE_FAILED;
         goto end;
      }
   efl_text_interactive_selection_allowed_set(obj, cval);
 end:
   eina_value_flush(&val);
   return r;
}

EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_text_interactive_selection_allowed_set, EFL_FUNC_CALL(allowed), Eina_Bool allowed);

static Eina_Value
__eolian_efl_text_interactive_selection_allowed_get_reflect(const Eo *obj)
{
   Eina_Bool val = efl_text_interactive_selection_allowed_get(obj);
   return eina_value_bool_init(val);
}

EAPI EAPI_WEAK EFL_FUNC_BODY_CONST(efl_text_interactive_selection_allowed_get, Eina_Bool, 0);
EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_text_interactive_selection_cursors_set, EFL_FUNC_CALL(start, end), Efl_Text_Cursor_Object *start, Efl_Text_Cursor_Object *end);
EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV_CONST(efl_text_interactive_selection_cursors_get, EFL_FUNC_CALL(start, end), Efl_Text_Cursor_Object **start, Efl_Text_Cursor_Object **end);

static Eina_Error
__eolian_efl_text_interactive_editable_set_reflect(Eo *obj, Eina_Value val)
{
   Eina_Error r = 0;   Eina_Bool cval;
   if (!eina_value_bool_convert(&val, &cval))
      {
         r = EINA_ERROR_VALUE_FAILED;
         goto end;
      }
   efl_text_interactive_editable_set(obj, cval);
 end:
   eina_value_flush(&val);
   return r;
}

EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_text_interactive_editable_set, EFL_FUNC_CALL(editable), Eina_Bool editable);

static Eina_Value
__eolian_efl_text_interactive_editable_get_reflect(const Eo *obj)
{
   Eina_Bool val = efl_text_interactive_editable_get(obj);
   return eina_value_bool_init(val);
}

EAPI EAPI_WEAK EFL_FUNC_BODY_CONST(efl_text_interactive_editable_get, Eina_Bool, 0);
EAPI EAPI_WEAK EFL_VOID_FUNC_BODY(efl_text_interactive_all_unselect);
EAPI EAPI_WEAK EFL_VOID_FUNC_BODY(efl_text_interactive_all_select);

static Eina_Value
__eolian_efl_text_interactive_have_selection_get_reflect(const Eo *obj)
{
   Eina_Bool val = efl_text_interactive_have_selection_get(obj);
   return eina_value_bool_init(val);
}

EAPI EAPI_WEAK EFL_FUNC_BODY_CONST(efl_text_interactive_have_selection_get, Eina_Bool, 0);

static Eina_Bool
_efl_text_interactive_class_initializer(Efl_Class *klass)
{
   const Efl_Object_Ops *opsp = NULL;

   const Efl_Object_Property_Reflection_Ops *ropsp = NULL;

#ifndef EFL_TEXT_INTERACTIVE_EXTRA_OPS
#define EFL_TEXT_INTERACTIVE_EXTRA_OPS
#endif

   EFL_OPS_DEFINE(ops,
      EFL_OBJECT_OP_FUNC(efl_text_interactive_main_cursor_get, NULL),
      EFL_OBJECT_OP_FUNC(efl_text_interactive_selection_allowed_set, NULL),
      EFL_OBJECT_OP_FUNC(efl_text_interactive_selection_allowed_get, NULL),
      EFL_OBJECT_OP_FUNC(efl_text_interactive_selection_cursors_set, NULL),
      EFL_OBJECT_OP_FUNC(efl_text_interactive_selection_cursors_get, NULL),
      EFL_OBJECT_OP_FUNC(efl_text_interactive_editable_set, NULL),
      EFL_OBJECT_OP_FUNC(efl_text_interactive_editable_get, NULL),
      EFL_OBJECT_OP_FUNC(efl_text_interactive_all_unselect, NULL),
      EFL_OBJECT_OP_FUNC(efl_text_interactive_all_select, NULL),
      EFL_OBJECT_OP_FUNC(efl_text_interactive_have_selection_get, NULL),
      EFL_TEXT_INTERACTIVE_EXTRA_OPS
   );
   opsp = &ops;

   static const Efl_Object_Property_Reflection refl_table[] = {
      {"selection_allowed", __eolian_efl_text_interactive_selection_allowed_set_reflect, __eolian_efl_text_interactive_selection_allowed_get_reflect},
      {"editable", __eolian_efl_text_interactive_editable_set_reflect, __eolian_efl_text_interactive_editable_get_reflect},
      {"have_selection", NULL, __eolian_efl_text_interactive_have_selection_get_reflect},
   };
   static const Efl_Object_Property_Reflection_Ops rops = {
      refl_table, EINA_C_ARRAY_LENGTH(refl_table)
   };
   ropsp = &rops;

   return efl_class_functions_set(klass, opsp, ropsp);
}

static const Efl_Class_Description _efl_text_interactive_class_desc = {
   EO_VERSION,
   "Efl.Text_Interactive",
   EFL_CLASS_TYPE_INTERFACE,
   0,
   _efl_text_interactive_class_initializer,
   NULL,
   NULL
};

EFL_DEFINE_CLASS(efl_text_interactive_interface_get, &_efl_text_interactive_class_desc, NULL, EFL_TEXT_INTERFACE, EFL_TEXT_FONT_PROPERTIES_INTERFACE, EFL_TEXT_FORMAT_INTERFACE, EFL_TEXT_STYLE_INTERFACE, NULL);
